hdu 2822(BFS+优先队列)

来源:互联网 发布:淘宝好评返现短信模板 编辑:程序博客网 时间:2024/06/05 22:34
题意:有一只小狗要去找另一只小狗,两只小狗的坐标都知道,地图里有两种元素,房子(X)还有草地(.),如果小狗经过房子,则不用花时间,如果经过的是草地,时间+1,最后算出小狗到达目标的时候所花费的最小时间。
思路:因为每个点的权值不一样,所以不能简单的BFS,要用优先队列,时间少的先出队即可



<span style="font-size:18px;">#include <cstdio>#include <queue>#include <cstring>#include <iostream>#include <cstdlib>#include <algorithm>#include <vector>#include <map>#include <string>#include <set>#include <ctime>#include <cmath>#include <cctype>using namespace std;#define maxn 1005#define LL long longint cas=1,T;char mapp[maxn][maxn];int vis[maxn][maxn];struct Node{char l;int x,y,time;    friend bool operator < (const Node&a,const Node&b){return a.time > b.time;}};int n,m,startx,starty,endx,endy;int dir[4][2]={{0,1},{0,-1},{1,0},{-1,0}};bool check(int x,int y){if (x<1 || x>m || y<1 || y>n || vis[x][y])return true;return false;}int bfs(){memset(vis,0,sizeof(vis));priority_queue<Node> q;Node s,temp;s.x=startx;s.y=starty;s.time=0;vis[s.x][s.y]=1;q.push(s);while (!q.empty()){s = q.top();q.pop();if (s.x==endx && s.y==endy)return s.time;for (int i = 0;i<4;i++){temp.x = s.x+dir[i][0];temp.y = s.y+dir[i][1];            if (check(temp.x,temp.y))continue;if (mapp[temp.x][temp.y]=='X')temp.time = s.time+0;elsetemp.time = s.time+1;vis[temp.x][temp.y]=1;q.push(temp);}}return -1;}int main(){while (scanf("%d%d",&m,&n)!=EOF && m && n){for (int i = 1;i<=m;i++)scanf("%s",mapp[i]+1);scanf("%d%d",&startx,&starty);scanf("%d%d",&endx,&endy);int ans = bfs();printf("%d\n",ans);}//freopen("in","r",stdin);//scanf("%d",&T);//printf("time=%.3lf",(double)clock()/CLOCKS_PER_SEC);return 0;}</span>





Description

Prairie dog comes again! Someday one little prairie dog Tim wants to visit one of his friends on the farmland, but he is as lazy as his friend (who required Tim to come to his place instead of going to Tim's), So he turn to you for help to point out how could him dig as less as he could. 

We know the farmland is divided into a grid, and some of the lattices form houses, where many little dogs live in. If the lattices connect to each other in any case, they belong to the same house. Then the little Tim start from his home located at (x0, y0) aim at his friend's home ( x1, y1 ). During the journey, he must walk through a lot of lattices, when in a house he can just walk through without digging, but he must dig some distance to reach another house. The farmland will be as big as 1000 * 1000, and the up left corner is labeled as ( 1, 1 ).
 

Input

The input is divided into blocks. The first line in each block contains two integers: the length m of the farmland, the width n of the farmland (m, n ≤ 1000). The next lines contain m rows and each row have n letters, with 'X' stands for the lattices of house, and '.' stands for the empty land. The following two lines is the start and end places' coordinates, we guarantee that they are located at 'X'. There will be a blank line between every test case. The block where both two numbers in the first line are equal to zero denotes the end of the input.
 

Output

For each case you should just output a line which contains only one integer, which is the number of minimal lattices Tim must dig.
 

Sample Input

6 6..X...XXX.X.....X.X.....X.....X.X...3 56 30 0
 

Sample Output

3

Hint

 Hint: Three lattices Tim should dig: ( 2, 4 ), ( 3, 1 ), ( 6, 2 ).          
 



0 0
原创粉丝点击